#!/usr/bin/awk -f

# Wep Dictionary Generator by SuD 
# 

# return positive modulus
function mod(a, r) {
	return ((a%r)+r)%r
}

function dprint(mens) {
#	print "xxxxxxxxxxxxxxxx" mens;
}

BEGIN { 
	LLEN=2;
	LEN[0]=5;
	LEN[1]=13;

dprint(0);
	# constants
	# 00000 01010101
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<256; i++) {
			for (j=0; j<len; j++) {
				printf("%02X", i); 
			}
			printf("\n");
		}
	}

dprint(1);
	# byte inc
	# 0001020304
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<256; i++) {
			for (j=0; j<len; j++) {
				printf("%02X", (i+j)%256);
			}
			printf("\n");
		}
	}
	# byte dec
	# 04030201
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<256; i++) {
			for (j=0; j<len; j++) {
				printf("%02X", mod(i-j,256));
			}
			printf("\n");
		}
	}

dprint(2);
	# nibble inc hex
	# 0123456789a
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len*2; j++) {
				printf("%X", (i+j)%16); 
			}
			printf("\n");
		}
	}
	# nibble dec hex
	# a9876543210a
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len*2; j++) {
				printf("%X", mod(i-j, 16)); 
			}
			printf("\n");
		}
	}

dprint(3);
	# 2nibble inc hex
	# 00112233..AA
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len; j++) {
				printf("%02X", (i+j)%16*0x11); 
			}
			printf("\n");
		}
	}
	# 2nibble dec hex
	# 33221100
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len; j++) {
				printf("%02X", mod(i-j,16)*0x11); 
			}
			printf("\n");
		}
	}

dprint(4);
	# 2nibble inc bcd
	# 00112233
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len; j++) {
				printf("%02d", (i+j)%10*11); 
			}
			printf("\n");
		}
	}

dprint(5);
	# 2nibble dec bcd
	# 00112233
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (i=0; i<16; i++) {
			for (j=0; j<len; j++) {
				printf("%02d", mod(i-j,10)*11); 
			}
			printf("\n");
		}
	}

dprint(6);

	# 2 nibble pair, threes, etc
	# 11221122  111222111
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (m=2; m<2*len; m++) {
			for (i=0; i<16; i++) {
			for (j=0; j<16; j++) {
				if (i==j)
					continue;
				for (k=0; k<2*len; k++) {
					if ((k%(2*m)) < m) {
						printf("%X", i); 
					} else {
						printf("%X", j); 
					}
				}
				printf("\n");
			}
			}
		}
	}

dprint(7);
	# seq rep bcd inc
	# 123123 12341234
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (n=0; n<10; n++) {
			for (m=3; m<=10; m++) { # period
				for (i=0; i<m; i++) {
					for (j=0; j<2*len; j++) {
						printf("%X", (((i+j)%m)+n)%10); 
					}
					printf("\n");
				}
			}
		}
	}

	# seq rep bcd dec
	for (l=0; l<LLEN; l++) {
		len=LEN[l];
		for (n=0; n<10; n++) {
			for (m=3; m<=10; m++) {
				for (i=0; i<m; i++) {
					for (j=0; j<2*len; j++) {
						printf("%X", (mod(n+i-j,m)+n)%10); 
					}
					printf("\n");
				}
			}
		}
	}


	# ToDo...
	# 111222333
	# ...
	# 0123456789987654321
	# rararara






}
